### Apriori file format computed by calc_skd
## Expected format is as
##    1 2005/307 23:34:35.000 2453678.48234954 KAS34511 - CHI10511 HYBS2336 -2.25212082678572910605e-03 -3.72174402503335495511e-08 El= 32.53  40.08 

package Apr_fmt;
use Exporter;
use Time_lib;
@ISA = qw(Exporter);

@EXPORT = qw();

# use AutoLoader 'AUTOLOAD';
# 1;
# __END__

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Tdat($$){
    my ($this, $i) = @_;
    my $ndat = $this->{ndat};
    my $tm = $this->{time};

    if($i >= $ndat || $i < 0){
	print STDERR "Error in Apr_fmt::Tdat(): Tdat($i) is out of range (<$ndat)\n";
	exit(1);
    }
    return $$tm[$i];
}

sub Del($$){
    my ($this, $i) = @_;
    my $ndat = $this->{ndat};
    my $del = $this->{del};
    if($i >= $ndat || $i < 0){
	print STDERR "Error in Apr_fmt::Del(): i=($i) is out of range (<$ndat)\n";
	exit(1);
    }
    return $$del[$i];
}

sub Rat($$){
    my ($this, $i) = @_;
    my $ndat = $this->{ndat};
    my $rat = $this->{rat};
    if($i >= $ndat || $i < 0){
	print STDERR "Error in Apr_fmt::Rat: i($i) is out of range (<$ndat)\n";
	exit(1);
    }
    return $$rat[$i];
}

sub Time2i($$){
    my ($this, $t1) = @_;
    my $ndat = $this->{ndat};
    my $del = $this->{del};
    my $tm = $this->{time};
    my $t2 = $$tm[0];
    my $i=0;
    for($i=0; $i<$ndat; $i++){
	last if($$tm[$i] == $t1 || $$tm[$i]->Soy() > $t1->Soy());
    } 
    
    if( ($i < $ndat) &&  ($$tm[$i] == $t1)){
	return $i;
    }else{
	return -1;
    }
}

sub Elx($$){
    my ($this, $i) = @_; 
    my $ndat = $this->{ndat};
    my $el_x = $this->{el_x};
    if($i >= $ndat || $i < 0){
	print STDERR "Error in Apr_fmt::Elx: i($i) is out of range (<$ndat)\n";
	exit(1);
    }
    return $$el_x[$i];
}

sub Ely($$){
    my ($this, $i) = @_;
    my $ndat = $this->{ndat};
    my $el_y = $this->{el_y};
    if($i >= $ndat || $i < 0){
	print STDERR "Error in Apr_fmt::Ely: i($i) is out of range (<$ndat)\n";
	exit(1);
    }
    return $$el_y[$i];
}

sub Ndat($){
    my $this = shift;
    return $this->{ndat};
}

sub Read($$){
    my ($this, $file) = @_;
    my (@tm, @stn_x, @src, @stn_y, @del, @rat, @el_x, @el_y);
    open(IN, $file)  || die "Cannot open file $file.\n";
    my $cnt=0;
    while(<IN>){
	next if(/^\#/);
	/\s*/;
	my @terms = split(/\s+/,$'); # ')
	if(@terms < 10){
	    print STDERR "Error in Apr_fmt::Read(): format may be wrong\n";
	    print STDERR "line = $_";
	    next;
	}
	my $tm0 = new Time_lib;
	$tm0->Set_time_strydhms($terms[1], $terms[2]);
	$tm[$cnt] = $tm0;
	$stn_x[$cnt] = $terms[4];
	$stn_y[$cnt] = $terms[6];
	$src[$cnt] = $terms[7];
	$del[$cnt] = $terms[8];
	$rat[$cnt] = $terms[9];
	$el_x[$cnt] = $terms[11] if(defined($terms[11]));
	$el_y[$cnt] = $terms[12] if(defined($terms[12]));
	$cnt++;
    }
    close(IN);
    $this->{ndat} = $cnt;
    $this->{src} = \@src;
    $this->{del} = \@del;
    $this->{time} = \@tm;
    $this->{rat} = \@rat;
    $this->{stn_x} = \@stn_x;
    $this->{stn_y} = \@stn_y;
    $this->{el_x} = \@el_x;
    $this->{el_y} = \@el_y;
    return $cnt;

}

1;
