package Pcal_dat;

use Mjd;

BEGIN{
    @NAdoy = qw( 31 59 90 120 151 181 212 243 273 304 334 365); 
    @Month = qw(Jan Feb Mar Apr May Jun 
		Jul Aug Sep Oct Nov Dec);
    %Month = ('Jan' =>1, 'Feb' =>2, 'Mar' =>3, 'Apr' =>4,
	      'May' =>5, 'Jun' =>6, 'Jul' =>7, 'Aug' =>8,
	      'Sep' =>9, 'Oct' =>10, 'Nov' =>11, 'Dec' =>12);
}

sub new ($$$){
    my ($pkg, $infile, $outfile) = @_;

    my @inflag = qw(1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 );
    my $this = {'infile' => $infile, 'outfile' => $outfile,  
		'inflag' => \@inflag};
    bless $this;
    $this;
}

sub Set_exclude_ch($\@)
{
    my ($this, $charr) = @_;
    my $inflag = $this->{inflag};
    my @ar = @$charr;
    print "Ch: ";
    while(@ar){
	my $d = shift(@ar);
	printf "%d ",$d
	}
    print " were excluded\n";
    

    while(@$charr){
	my $ch = shift(@$charr);
	$$inflag[$ch-1] =0;
    }
} 

sub ndat($){
    my $this = shift;
    $this->{ndat};
}
sub soy($){
    my $this = shift;
    $this->{soy};
}
sub sod($){
    my $this = shift;
    $this->{sod};
}
sub amp($){
    my $this = shift;
    $this->{amp};
}
sub amp1($){
    my $this = shift;
    $this->{amp1};
}
sub phs($){
    my $this = shift;
    $this->{phs};
}
sub phs1($){
    my $this = shift;
    $this->{phs1};
}
sub phs2($){
    my $this = shift;
    $this->{phs2};
}

sub Read_dat($$){
    my ($this, $yy) = @_;
    my $file = $this->{infile};
    open(IN, $file) || die "Cannot open file $file \n";
    my $flag =0;
    my (@soy, @sod, @doy, @mjd, @amp, @phs, @tdat, @frq);
    my @ch_cnt =qw(0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0);
    my $cnt=0;
    my $m_overyear=0;
    my $prev_month = 0;
    while(<IN>){
	/^\s*/;
	my @terms = split(/[\s:,]+/,$');
	next if (@terms < 7);
	if(/^\#/){
	    shift(@terms);
	    @frq = @terms;
	    next;
	}
	if(&sum(@ch_cnt) ==0){
	    my $dd = $terms[0];
	    my $Mon = $terms[1];
	    my $hh = $terms[2];
	    my $mm = $terms[3];
	    my $mon = $Month{$Mon};
	    $sod[$cnt] = $hh*3600. + $mm * 60.;
	    $yy ++ if($mon ==1 && $prev_month == 12);
	    if(($mjd[$cnt] =  mjd($yy, $mon, $dd)) ==0){
		print STDERR "Error yy($yy) Mon($Mon) $dd($dd) is not correct\n";
		exit(0);
	    }
	    $mjd[$cnt] += $sod[$cnt];
	    $doy[$cnt] =  &doy($yy, $mon, $dd);
	    $soy[$cnt] =  $doy[$cnt]*86400. + $sod[$cnt];
	    $tdat[$cnt] = sprintf("%04d/%03d %02d:%02d",
				  $yy, $doy[$cnt], $hh, $mm );
	    $prev_month = $mon;
	}
	my $ch = int($terms[6])-1;
	$ch_cnt[$ch] =1;
	$amp[$ch][$cnt] = $terms[4];
	$phs[$ch][$cnt] = $terms[5];
	
	if(&sum(@ch_cnt) == 16){
	    @ch_cnt =qw(0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0);
	    $cnt++;
	}
    }
    close(IN);

    my $inflag =  $this->{inflag};
    my (@phs1, @amp1);
    my $ich =0;
    for($i=0; $i<16; $i++){
	next unless($$inflag[$i]);
	$phs1[$ich] = $phs[$i];
	$amp1[$ich] = $amp[$i];
	$ich++;
    }
    $this->{mjd} = \@mjd;
    $this->{doy} = \@doy;
    $this->{soy} = \@soy;
    $this->{sod} = \@sod;
    $this->{tdat} = \@tdat;    
    $this->{amp} = \@amp;

    $this->{amp1} = \@amp1;    
    $this->{phs} = \@phs;
    $this->{phs1} = \@phs1;
    $this->{ndat} = $cnt;
    $this->{frqarr} = \@frq;
}

sub sum(@){
    my $sum =0;
    $sum += shift while(@_);
    $sum;
}
sub File_out($$)
{
    my ($this, $v) = @_;

    my $outfile = $this->{outfile};
    unless(defined($outfile)){
	print STDERR "Error: outfile ($outfile) was not defined \n";
	return;
    }
    open(OUT, ">$outfile") || die "Cannot open outfile $outfile \n";
    my ($phs, $amp);
    my $tdat = $this->{tdat};
    if($v ==1){ ## /* Raw (ch selected) data */
	$phs = $this->{phs1};
	$amp = $this->{amp1};
    }else{      ## /* Phase connected data */
	$phs = $this->{phs2};
	$amp = $this->{amp1};
    }
    my $pfrq = $this->{frqarr};
    my $nch = @$phs;
    my $ndat = @{$$phs[0]};
    print OUT "# nch = %nch ndat = $ndat\n";
    print OUT "#frq= ";
    for($i=0; $i<@$pfrq; $i++){
	printf OUT "%.3lf ", $$pfrq[$i];
    }
    print OUT "\n";
    for($j=0; $j<$ndat; $j++){
	printf OUT "%s ", $$tdat[$j];
	for($i=0; $i<$nch; $i++){
	    printf OUT "%4.1lf %+6.1lf ", $$amp[$i][$j], $$phs[$i][$j];
	}
	print OUT "\n";
    }
    close(OUT);

}

sub Phase_con($)
{
    my $this = shift;
    my $phs = $this->{phs1};

    my $nx = @$phs;
    my $ny = @{$$phs[$nx-1]};
    
    my @phs2;

    my $icnt=0;
    for($i=0; $i<$nx; $i++){
	$phs2[$icnt][0] =$$phs[$i][0];
	my $ofst=0;
	for($j=1; $j<$ny; $j++){
	    if($$phs[$i][$j] - $$phs[$i][$j-1] > 180 ){
		$ofst -= 360.;
	    }elsif($$phs[$i][$j] - $$phs[$i][$j-1] < -180){
		$ofst += 360.;
	    }
	    $phs2[$icnt][$j] = $$phs[$i][$j] + $ofst;
	}
	$icnt++;
    }
    $this->{phs2} = \@phs2;
}

1;
