package Sdelay_tst;
use Exporter;
@ISA = qw(Exporter);
use Time_lib;

@EXPORT = qw(Read_sdelarr Ret_result Ret_nobs Ret_tau);

BEGIN{
    ;
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}



sub Ret_nobs($){
    my $this = shift;
    my $dbarr = $this->{sdel_arr};
    my $nobs = @$dbarr;
}

sub Ret_result($$){
    my ($this, $iobs) = @_;
    my $dbarr = $this->{sdel_arr};
    my $sdel_dt = $$dbarr[$i];

    my $rslt = $sdel_dt->{results};
    my @terms = split(/[\s\t]+/, $$rslt[0]);
}

sub Ret_tau($$){
    my ($this, $iobs) = @_;
    my $dbarr = $this->{sdel_arr};
    my $sdel_dt = $$dbarr[$i];

    my $taus = $sdel_dt->{tau};
    
    return (@$taus);

}


sub Read_sdelarr($$){
    my ($this, $file) = @_;
    
    open($file, $file) || die "Error: Cannot open file $file\n";
    
    while(!eof(IN)){
	Read_sdeldat(IN);
    }
    close(IN);
}

sub Read_sdeldat($$){
    my ($this, $in) = @_;
    
    my $db_arr = $this->{sdel_arr};
    my $line;
    while($line !~/\$OBS/ && !eof($in)){
	$line = <$in>;
    }
    if(eof($in)){
	print STDERR "EOF found\n";
	last;
    }
    
    my %sdel_db;
    
    my $flag=0;    
    while($flag<0 && !eof($in)){
	my $line = <$in>;
	my @terms = split(/[\s\t]+/, $line);
	next if (@terms <1);
	if($terms[0] =~/\$BASELINE/){
	    $sdel_db{xstname} = $terms[1];
	    $sdel_db{ystname} = $terms[2];
	}elsif($terms[0] =~/\$PRT/){
	    my $tim_dt = new Time_lib;
	    $time_dt->Set_time_ydhms($terms[1], $terms[2], 
				     $terms[3], $terms[4], 
				     $terms[5]);
	    $sdel_db{prt} = $time_dt;
	}elsif($terms[0] =~/\$SOURCE/){
	    $sdel_db{src_name} = $terms[1];
	}elsif($terms[0] =~/SAMPLING/){
	    $sdel_db{Samplingf} = $terms[1];
	}elsif($terms[0] =~/VIDEO_BW/){
	    $sdel_db{VBW} = $terms[1];
	}elsif($terms[0] =~m!NUMBER!){
	    $sdel_db{NPP} = $terms[3];
	}elsif($terms[0] =~m!SEKIBUN!){
	    $sdel_db{NPP} = $terms[1];
	}elsif($terms[0] =~m!APRIORI!){
	    $line = <$in>;
	    my @sterms = split(/s+/, $line);
	    $sdel_db{tau} = \@sterms;
	}
    }
    
#    push(@$db_arr, (\%sdel_db));
    push (@arr, ("aa", "bb"));
    $this->{sdel_arr} = $db_arr;
}

1;
