package Src_db;
use Exporter;
use Carp;

@ISA = qw(Exporter);

BEGIN{
    $PI = atan2(1,1)*4.;
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

# Expecting ddhddmdd.dddds
sub Set_ra_str($$$){
    my ($pkg, $srcname, $ra) = @_;
    unless(defined($pkg->{$srcname})){
	my %src;
	$pkg->{$srcname} = \%src;
    }
    my @hms = split(/[hms]+/,$ra);
    if(@hms < 3){
	print STDERR "Error in Src_db::Set_ra_str(): format is unexpected\n";
	print STDERR "ra = $ra\n";
	return -1;
    }
    ${$pkg->{$srcname}}->{ra} =\@hms;
    return 0;
}
# expecting ddddd'dd.dddd"  #"
sub Set_dec_str($$$){
    my ($pkg, $srcname,$dec) = @_;
    unless(defined($pkg->{$srcname})){
	my %src;
	$pkg->{$srcname} = \%src;
    }
     my @dms = split(/[d,\',\"]+/,$ra); #"
    if(@dms < 3){
	print STDERR "Error in Src_db::Set_dec_str(): format is unexpected\n";
	print STDERR "dec = $dec\n";
	return -1;
    }

    ${$pkg->{$srcname}}->{dec} =\@dms;
    return 0;
}

sub Set_ref_str($$$){
    my ($pkg, $srcname,$ref) = @_;
    unless(defined($pkg->{$srcname})){
	my %src;
	$pkg->{$srcname} = \%src;
    }

    ${$pkg->{$srcname}}->{ref} =$ref;
    return 0;
}


sub Dec_rad($$){
    my ($pkg,$src) = @_;
    unless(defined($pkg->{$src})){
	print STDERR "Error in Src_db::dec_rad(): srcname ($src) is undefd\n";
	return -1;
    }
    my $dec_dms = ${$pkg->{$src}}->{dec};
    my $sgn = $$dec_dms[0] > 0 ? 1 : -1;
    my $dd =  $$dec_dms[0] * $sgn;
    my $dec_deg = ((($$dec_dms[2]/60.+$$dec_dms[1])/60.)+$dd) * $sgn;
    
    my $dec_rad = $dec_deg*$PI/180.;
}


sub Ra_rad($$){
    my ($pkg,$src) = @_;
    unless(defined($pkg->{$src})){
	print STDERR "Error in Src_db::Ra_rad(): srcname ($src) is undefd\n";
	return -1;
    }
    my $ra_hms = ${$pkg->{$src}}->{ra};
    my $ra_deg = ((($$ra_hms[2]/60.+$$ra_hms[1])/60.)+$$ra_hms[0])*15.;
    
    my $ra_rad = $ra_deg*$PI/180.;
}

sub Read_vex($$){
    my ($pkg, $in) = @_;
    my $p = caller;
    my $H;
    if(defined($in)){
	if($in !~/^main/){ $H = $p . "::" . $in;}
	else{ $H =  $in;}
    }else{
	print STDERR "Error in Src_db::Read(): in undefined\n";
	return -1;
    }
    my $isrc=0;
    my @src_arr;
    my $line = <$H>;
    while(!eof($H)){
	next if($line =~/^\*/);
	if($line =~/^def\s+(\S+);/){
	    $src_name = $1;
	    push(@src_arr,($src_name));
	    $flag=1;
	    next;
	}
	my %srcdb;
	while(!eof($H) && $flag==1){
	    next if($line =~/^\*/);
	    if($line =~/source_name\s*=\s*(\S+)\s*;/){ ;}
	    if($line =~/ra\s*=\s*(\S+)\s*;/){ 
		my $tmp = $1;
		my @hms = split(/[hms]/,$tmp);
		if(@hms < 3){
		    print STDERR "Error in Src_db::Read_vex(): RA format is unexpected.\n";
		    print STDERR "line= $tmp \n";
		    next;
		} 
		$srcdb{ra} = \@hms;
#		$pkg->Set_ra_str($src_name,$tmp);
	    }
	    if($line =~/dec\s*=\s*(\S+)\s*;/){ 
		my $tmp = $1;
		my @dms = split(/[d\'\"]/,$tmp);
		if(@dms < 3){
		    print STDERR "Error in Src_db::Read_vex(): DEC format is unexpected.\n";
		    print STDERR "line= $tmp \n";
		    next;
		} 
		$srcdb{dec} = \@dms;
#		my $tmp = $1;
#		$pkg->Set_dec_str($src_name,$tmp);
	    }
	    if($line =~/ref_coord_frame\s*=\s*(\S+)\s*;/){
# 		my $tmp = $1;
		$srcdb{ref} = $1;
# 		$pkg->Set_ref_str($src_name,$tmp);
 	    }
	}continue{
	    $line = <$H>  unless(eof($H));
	    if($line =~/enddef/){
		$flag=0;
		$pkg->{$src_name} = \%srcdb;
		$isrc++;
		last;
	    }
	}
    }continue{
	$line = <$H>  unless(eof($H));
	last if($line =~/^\$/ );
    }
    return $line;
}

sub Src_list($$){
    my ($pkg,$sname) = @_;
    return keys(%$pkg);
}

sub Ra_str($){
    my ($pkg,$sname) = @_;
    my $sdb =$pkg->{$sname};
    my $hms = $sdb->{ra};
    my $str = sprintf "%3d %2d %7.4f", @$hms;
}

sub Dec_str($){
    my ($pkg,$sname) = @_;
    my $sdb =$pkg->{$sname};
    my $dms = $sdb->{dec};
    my $str = sprintf "%+3d %2d %7.4f", @$dms;
}

sub Print_src($$;$){
    my ($pkg,$sname, $out) = @_;
    $out = STDOUT unless(defined($out));
    my $srcdb = $pkg->{$sname};
    unless(defined(%$srcdb)){
	print STDERR "Error: Sourcename($sname) is not in the Data\n";
	return -1;
    }
    my $sra = $pkg->Ra_str($sname);
    my $sdec = $pkg->Dec_str($sname);
    printf $out "%-8s %s %s %s \n",
    $sname,  , $sra ,$sdec, $srcdb->{ref};

}

1;

