package TCPIP;
use strict "subs";
use Socket;
use Exporter;
@ISA=qw(Exporter);
@EXPORT = qw(tcp_server tcp_client);

#
#  Usage:  tcp_server(HANDLE [, PORT=32001])
#

sub tcp_server ($$) {
    my ($S, $port) = @_;
    my $pack = caller;
    $S = $pack . "::" . $S;
    $port = $port || 32001;
    $proto = getprotobyname('tcp');
    $port = getservbyname($port, 'tcp') unless $port =~/^\d+/;

    socket($S, PF_INET, SOCK_STREAM, $proto) || die "socket: $!";
    $ent = sockaddr_in($port, INADDR_ANY);
    bind($S, $ent) || die "bind $!";
    listen($S,5) || die "listen: $!";
}


#
# Usage:  tcp_client HANDLE [, HOST [, PORT=32001]]
#
sub tcp_client ($;$$) {
    my ($S, $host, $port) = @_;
    my $pack = caller;
    $S = $pack . "::" . $S;
    $host = $host || "localhost";
    $port = $port || 32001;

    my $proto = getprotobyname('tcp');
    socket($S, PF_INET, SOCK_STREAM, $proto);
print "port = $port\n";    
    $port = getservbyname($port, 'tcp') unless $port =~ /^\d+/;
    unless( $port =~ /^\d+/){
	print "cannot get port: $port ";
	exit(1);
    } 
print "port = $port\n";    
    my $host_ip = inet_aton($host);
print "host = $host_ip \n";	
    $ent = sockaddr_in($port, inet_aton($host));
    connect($S, $ent) || die "connect : $!";
    # Stop buffering 
    select($S); $| =1; select(STDOUT);
}

1;




















