## Time tagged data file 
## Expected format is yyyy/doy hh:mm:ss <data1> <data2> <data3> <data4>...
package Tdat;
use Exporter;
use Time_lib;
@ISA = qw(Exporter);

@EXPORT = qw();

BEGIN{
 
}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Ndat($){
    my $this = shift;
    return ($this->{mdat}, $this->{ndat});
}

sub Dval($$$){
   my ($this, $i, $j) = @_;
   my $ndat = $this->{ndat};
   my $mdat = $this->{mdat};
   my $darr = $this->{darr};

   if( $i < 0 || $i >= $mdat || $j >= $ndat){
       print STDERR "Error: index of Darr($i, $j) is out of range ($mdat, $ndat)\n";
       exit(1);
   }
   return $$darr[$i][$j];
}

sub Tarr($){
    my $this = shift;
    return $this->{tarr};

}

sub Time($$){
    my ($this, $i) = @_;
    my $ndat = $this->{ndat};
    my $tarr = $this->{tarr};
    if( $i < 0 || $i >= $ndat){
	print STDERR "Error: index of Tarr($i) is out of range ndat = $ndat\n";
	exit(1);
    }
    return $$tarr[$i];
}

sub Read($$){
    my ($this, $fname) = @_;

    open(IN,$fname) || die "Cannot open file \n";
    my $cnt=0;
    my (@tarr, @darr);
    while(<IN>){
	next if (/^\#/);
	/\s*/;
	my @terms = split(/\s+/, $'); # ')
	next if( @terms < 3);
	my $t1 = new Time_lib;
	$t1->Set_time_strydhms($terms[0],$terms[1]);
	my $ncol = @terms;
	$mdat = $ncol -2;
	
	push(@tarr,$t1);
	for(my $i=0; $i<$mdat; $i++){
	    push(@{$darr[$i]}, $terms[$i+2]);
	}
	$cnt++;
    }
    close(IN);

    $this->{ndat} = $cnt;
    $this->{mdat} = $mdat;
    $this->{tarr} = \@tarr;
    $this->{darr} = \@darr;
}

1;
