package Vex_skd;
use Exporter;
use Carp;

use Frq_db;
use Sched_db_vex;
use Src_db;
use Stn_db;

@ISA = qw(Exporter);
@EXPORT = qw(Read_exprt);
#@EXPORT = qw(Mjd Doy Soy Sod Print_fmt1 Print_fmt2 Print_fmt3 
#	     Print_fmt4 Print_fmt10 Str_fmt3 Set_mjd2Time 
#	     Set_time_strydhms Set_time_strymdhms);

BEGIN{
}

sub new ($){
    my $pkg = shift;
    my $skd = new Sched_db_vex;
    my $src = new Src_db;
    my $frq = new Frq_db;
    my $stn = new Stn_db;
    my $this = {skd=>$skd,src=>$src,frq=>$frq, stn=>$stn};
    bless $this;

}

sub Read($$){
    my ($pkg, $fname) = @_;
    $pkg->{fname} = $fname;
    unless(open(IN,$fname)){
	print STDERR "Cannot opne VEXfile $fname \n";
	return -1;
    }
    my $line =<IN>;
    while(!eof(IN)){
	if(!defined($line) && $line =~/^\*/){
	    print "line = $line";
	    next;}
	if($line=~/VEX_rev/){ 
	    my @terms = split(/[\s,;]+/,$line); 
	    $pkg->{VEX_ver} = $terms[2];
	}elsif($line=~/^\$GLOBAL/){
	    my $line = <IN>;
	    $line = <IN>  while($line !~/\$EXPER/);
	    $line =~/\s*/;
	    my @terms = split(/[\s,;]+/,$'); # ')
	    $pkg->{expcode} = $terms[3];
	    print STDERR "GLOBAL\n";
	}elsif($line=~/^\$EXPER/){ $pkg->Read_exper();	}
	elsif($line=~/^\$SITE/){ 
	    $line = $pkg->{stn}->Read_site_vex(IN); 
	    print STDERR "SITE\n"; redo;
	}
	elsif($line=~/^\$FREQ/){ 
	    $line = $pkg->{frq}->Read_vex(IN); 
	    print STDERR "FREQ\n";
	    redo;}
	elsif($line=~/^\$SOURCE/){ 
	    $line = $pkg->{src}->Read_vex(IN); 
	    print STDERR "SOURCE\n";
	    redo;}
	elsif($line=~/^\$SCHED/){ 
	    $line = $pkg->{skd}->Read(IN); 
	    print STDERR "SCHED\n";
	    redo;}
    }continue{
	$line = <IN>;
    }
    return 0;
}
sub Stn_list($){
    my $pkg = shift;
    $pkg->{stn}->Stn_list();
}

sub Print_stn($$;$){
    my ($pkg,$stn, $out) = @_;
    $out = STDOUT unless(defined($out));
    $pkg->{stn}->Print_stn($stn,$out);
}

sub Src_list($){
    my $pkg = shift;
    $pkg->{src}->Src_list();
}


sub Print_src($$;$){
    my ($pkg,$src, $out) = @_;
    $out = STDOUT unless(defined($out));
    $pkg->{src}->Print_src($src,$out);
}

sub Frq_list($){
    my $pkg = shift;
    $pkg->{frq}->Mode_list();
}

sub Print_frq_mode($$){
    my ($pkg,$mode,$out) = @_;
    my $frq = $pkg->{frq};
    my $nch = $frq->Nch($mode);
    printf  $out " FRQ: %s \n", $mode;
    for(my $j=0; $j<$nch; $j++){
	$frq->Print_ch($mode,$j+1);
    }
}

sub Print_frq_all($$;$){
    my ($pkg,$mode,$out) = @_;
    my $frq = $pkg->{frq};
    my @mode_arr = $frq->Mode_list();
    foreach my $m (@mode_arr){
	$pkg->Print_frq_mode($m);
    }
}

sub Nskd($){
    my $pkg = shift;
    $pkg->{skd}->Nskd();

}

sub Print_skd($$$){
    my ($pkg,$i,$out) = @_;
    
    $pkg->{skd}->Print_skd($i,$out);

}
## mode =0 return yy soy
## mode =1 return yy doy sod
## mode =2 retrun yy doy hh mm ss
## mode =3 return Time_lib;
sub Skd_start($$;$){
    my ($pkg, $i,$mode) = @_;
    $pkg->{skd}->Start($i,$mode);

}

sub Mode($$){
    my ($pkg, $i) = @_;
    $pkg->{skd}->Mode($i);
}

sub Source($$){
    my ($pkg, $i) = @_;
    $pkg->{skd}->Src_name($i);
}

sub Ids($$){
    my ($pkg, $i) = @_;
    my $dur_list = $pkg->{skd}->ID_list($i);
    my @id_arr = keys(%$dur_list);
}

sub Skd_dur($$;$){
    my ($pkg,$i,$id) = @_;
    $pkg->{skd}->Dur($i,$id);
}

# sub Read_src($){
#     my$pkg=shift;
#     my $line;
#     my $flag=0;
#     my $src_name;
#     my @src_arr;
    
#     while($line !~/^\$/){    
# 	next if($line =~/^\*/);
# 	if($line =~/^def\s+(\S+);/){
# 	    $src_name = $1;
# 	    push(@src_arr,($src_name));
# 	    $src_db{$src_name} = new Src_db;
# 	    $flag=1;
# 	    next;
# 	}elsif($line =~/^enddef;/){
# 	    $flag=0; 
# 	    next;
# 	}
# 	if($flag ==1){
# 	    if($line =~/ra\s*=\s*(\S+)\s*;/){
# 		my $tmp = $1;
# 		$src_db{$src_name}->Set_ra_str($src_name,$tmp);
# 	    }
# 	    if($line =~/dec\s*=\s*(\S+)\s*;/){
# 		my $tmp = $1;
# 		$src_db{$src_name}->Set_dec_str($src_name,$tmp);
# 	    }
	    
# 	    if($line =~/ref_cood_frame\s*=\s*(\S+)\s*;/){
# 		my $tmp = $1;
# 		$src_db{$src_name}->Set_ref_str($src_name,$tmp);
# 	    }
# 	}continue{
# 	    $line = <IN>;
# 	}
#     }
#     $pkg->{src_db} = \%src_db;
#     $pkg->{mode_arr} = \@src_arr;
    
#     return $line;
# }

# sub Read_freq($){
#     my$pkg=shift;
#     my $line;
#     my $flag=0;
#     my $frq_mode;
#     my @mode_arr;
#     my %frq_db;
#     while($line !~/^\$/){    
# 	next if($line =~/^\*/);
# 	if($line =~/^def\s+(\S+);/){
# 	    $frq_mode = $1;
# 	    push(@mode_arr,($frq_mode));
# 	    $frq_db{$frq_mode} = new Frq_db;
# 	    $flag=1;
# 	    next;
# 	}elsif($line =~/^enddef;/){
# 	    $flag=0; 
# 	    next;
# 	}elsif($line =~/sample_rate\s*=\s*(\S+)\s+Ms/sec;/){
# 	    $frq_db{frq_mode}->Set_Sampling($1);
# 	}elsif($line =~/chan_def\s*=\s*:\s*/){
# 	    my @terms = split(/[\s,:]+/,$'); #')
# 	    my $rf = $terms[0];
# 	    my $ul = $terms[2];
# 	    my $bw = $terms[3];
# 	    unless($terms[5] =~/&CH(\d+)/){
# 		printf STDERR "Error in Vex_skd::Read_frq(): frq format is unexpected\n";
# 		print STDERR " line = $line\n";
# 		next;
# 	    }
# 	    my $ch = $1;
# 	    $frq_db{frq_mode}->Set_rfrq($ch,$rf);
# 	    $frq_db{frq_mode}->Set_bw($ch,$bw);
# 	    $frq_db{frq_mode}->Set_ulsb($ch,$ul);
# 	    $frq_db{frq_mode}->Set_ulsb($ch,$ul);
# 	}
#     }continue{
# 	$line = <IN>;
#     }
#     $pkg->{frq_db} = \%frq_db;
#     $pkg->{mode_arr} = \@mode_arr;

#     return $line;
# }

# sub Read_site($){
#     my$pkg=shift;
#     my $line;
#     my $flag=0;
#     my %stid;
#     my @stname;
#     my $site_name;
#     while($line !~/^\$/){    
# 	next if(/^\*/);
# 	if($line =~/^def\s+(\S+);/){
# 	    $site_name = $1;
# 	    push(@stname,($site_name));
# 	    $flag=1;
# 	    next;
# 	}elsif($line =~/^enddef;/){
# 	    $flag=0; 
# 	    next;
# 	}elsif(/site_name\s*=\s*(\S+);/){
# 	    $stid{$site_name} = $1;
# 	}elsif(/site_position\s*=\s*(\S+)\s*m*:\s*(\S+)\s*m*:\s*(\S+)\s*m*;/){
# 	    my @xyz = ($1, $2, $3);
# 	    $st_pos{$site_name} = \@xyz;
# 	}
#     }continue{
# 	$line = <IN>;
#     }
#     $pkg->{stname} = \@stname;
#     $pkg->{st_id} = \%stid;
#     $pkg->{st_pos} = \%st_pos;

#     return $line;
# }

sub Read_exper($){
    my$pkg=shift;
    my $line = <IN>;
    while($line !~/enddef/){
	next if($line =~/^\*/);
	if($line =~/exper_name\s*=\s*(\S+);/){
	    $pkg->{expcode} = $1;
	}elsif($line =~/exper_description \s*=\s*\"(\S+)\"/){ # "
	    $pkg->{exp_descript} = $1;
	}
    }continue{
	$line = <IN>;
	if($line=~/enddef/){
	    last;
	}
    }
}

sub Write_skd($$$$$$\@;$){
    my ($pkg,$i, $t1, $mode, $src, $dur, $ids,$out) =@_;
    my $H;
    my $p = caller;
    if(defined($out)){
	if($out !~/^main/){ $H = $p . "::" . $out;}
	else{ $H =  $out;}
    }else{
	$H = STDOUT;
    }
    
    printf $H "scan No%04d;\n",$i;
    printf $H "     start=%s; mode=%s; source=%s;\n",
    $t1->Str_fmt1(2),$mode,$src;
    foreach $s (@$ids){
	printf $H "     station=%s:   0 sec: %4d sec:  0.000 GB:  :    :  1;\n",
	$s, $dur;
    }
    print $H "endscan;\n";
}

1;
