package Wx_lib;
use Exporter;
use Carp;
use Time_lib;
@ISA = qw(Exporter);

#@EXPORT = qw(Mjd Doy Soy Sod Print_fmt1 Print_fmt2 Print_fmt3 
#	     Print_fmt4 Print_fmt10 Str_fmt3 Set_mjd2Time 
#	     Set_time_strydhms Set_time_strymdhms Set_time_ydhms);

BEGIN{
    %indx = ( 'Temp' => 0, 'Pres' => 1, 'Humd' => 2, 
	      'WDir' => 3, 'Wmax' => 4, 'Wavg' => 5);

}

sub new ($){
    my $pkg = shift;
    my $this = {};
    bless $this;
    $this;
}

sub Read($$$){
    my ($pkg, $fname, $vname) = @_;
    unless( open(IN,$fname)){
	print STDERR "Wx_lib::Read(): Open($fname) failed.\n";
	return -1;
    }
    
    my $ival = $indx{$vname};
    unless(defined($ival)){
	print STDERR "Wx_lib::Read(): Parameter name($vname) mismatch\n";
	my @par = keys(%indx);
	my $lst = join(" ", @par);
	print STDERR " Parmeter must be one of '$lst' \n";
	return -1;
    }
    
    my (@tarr, @varr);
    my $cnt =0;
    while(<IN>){
	next if(/^\#/);
	unless(m!(\d{4}).(\d{3}).(\d\d):(\d\d):([\d.]+)/wx/(.*)!){
	    print STDERR "Wx_lib::Read(): timecode mismatch: $_\n";
	    next;
	}

	my $vstr = $6;
	my $tm = new Time_lib;
	$tm->Set_time_ydhms($1,$2,$3,$4,$5);
	my @terms = split(/,/, $vstr);	
	if(@terms < $ival){
	    print STDERR "Wx_lib::Read(): parameter($vname) not found at col=$ival\n";
	    next;
	}
	$tarr[$cnt] = $tm;
	$varr[$cnt++] = $terms[$ival];

    }
    close(IN);
    $pkg->{tarr} = \@tarr;
    $pkg->{varr} = \@varr;
    
    return 0;
}

sub Tarr($){
    my $pkg = shift;
    @{$pkg->{tarr}};
}

sub Varr($){
    my $pkg = shift;
    @{$pkg->{varr}};
}

1;
